<?php

/***************************************************************************
 * 
 *  Name: Dynamic Data Display
 *  URI: http://armopelus.com
 *  Description: Display your Dynamic Forms data the way you like it.
 *  Author: Armopelus
 *  Version: 1.0
 *  Tags: dynamic data, display, dynamic forms, data, GPL
 * 
 ****************************************************************************/
 
/// Register module into system!
modules::register(
'DynamicData', 
_('Dynamic Data Display'),
_('Display your Dynamic Forms Data the way you like it.'));
	
 class dynamicData extends modules {
 	
	var $adminPath = 'admin/modules/dynamicdata';
	
	
	var $cssFile;	
	var $jsFile;
	var $modulePath;
        var $moduleURL;
	var $globalAdminPath;      
    
	
	function __construct() {
		languages::load('dynamicData');	

                 $this->modulePath 		= $this->checkInstallation();      
                 $this->moduleURL 		= $this->checkInstallation("URL");      
                 @require_once($this->modulePath."lib/modules/dynamicdata/parser/stringparser_bbcode.class.php");
                $this->cssFile			=  $this->modulePath . "lib/modules/dynamicdata/css/dynamicdata.css";
                $this->jsFile			=  $this->modulePath . "lib/modules/dynamicdata/js/admin.js";
                $this->globalAdminPath          =  SITE_URL.'admin/?path=';
                

	}
	function __destruct() {
		languages::unload('dynamicData');
	}
	
	function checkInstallation($type = null)
	{
		if(defined('JCORE_PATH'))
		{
			if(@is_file(JCORE_PATH."lib/modules/dynamicdata/dynamicdata.class.php"))
			{
                        if($type == "URL"){
			return JCORE_URL;
                        }else {
			return JCORE_PATH;
                        }
			}
		}
			else
			{
                        if($type == "URL"){
			return SITE_URL;
                        }else {
			return SITE_PATH;
                        }
			}
		
	}
	
	function readCSS() {

		$file = $this->cssFile;
                
                
	        	if (!$fo   = @fopen($file, 'r')) {
				tooltip::display(
					sprintf(_("CSS File couldn't be found!")),
					TOOLTIP_ERROR);
				return false;
				}
	        	
				$data = fread($fo, filesize($file));
				fclose($fo);
				
					return $data;			
		
	}

	
	function readJS() {
		$file = $this->jsFile;
		
	        	if (!$fo   = @fopen($file, 'r')) {
				tooltip::display(
					sprintf(_("JS File couldn't be found!")),
					TOOLTIP_ERROR);
				return false;
				}
	        	
				$data = fread($fo, filesize($file));
				fclose($fo);
				
					return $data;			
		
	}
	
	function installSQL() {
		sql::run(
			"CREATE TABLE IF NOT EXISTS `{dynamicdata}` (" .
			" `ID` smallint(5) unsigned NOT NULL auto_increment," .
			" `FormID` smallint(5) unsigned NOT NULL ," .
			" `Name` varchar(255) NOT NULL default ''," .
			" `Title` varchar(255) NOT NULL default ''," .
			" `Fields` varchar(255) NOT NULL default ''," .
			" `Order` varchar(255) NOT NULL default ''," .
			" `Limit` smallint(5)  NOT NULL default '5'," .
			" `htmlstyle` mediumtext  NOT NULL default ''," .
			" PRIMARY KEY  (`ID`)" .
			" ) ENGINE=MyISAM;");
		
		if (sql::error())
			return false;
		
		return true;
	}
	
	function installFiles() {
		$css = $this->readCSS();	
		return 
			files::save(SITE_PATH.'template/modules/css/dynamicdata.css', $css);
	}
	
	function uninstallSQL() {
		return
			sql::run(
				" DROP TABLE IF EXISTS `{dynamicdata}`;");
	} 
	
	function uninstallFiles() {
		return 
			files::delete(SITE_PATH.'template/modules/css/dynamicdata.css');
	}
        
        function rebuildCSS()
        {
			files::delete(SITE_PATH.'template/modules/css/dynamicdata.css');
                        $css     = $this->readCSS();
                        $css    .= $this->readCSS("ext");
		return 
			files::save(SITE_PATH.'template/modules/css/dynamicdata.css', $css);
                     
        }
	
	function countAdminItems() {
		if (!parent::installed($this))
			return 0;
		
		$row = sql::fetch(sql::run(
			" SELECT COUNT(*) AS `Rows`" .
			" FROM `{dynamicdata}`" .
			" LIMIT 1"));
		return $row['Rows'];
	}	
	
	
		//// Administration part
		function displayAdminDescription() {

		echo 
			"<p>" .
				_("Create and display data from your Dynamic Forms in a way you like it.") .
			"</p>";	

		}
		
		function jQueryFunctions()
		{	
			echo "\n<script type='text/javascript'>\n".
				 $this->readJS().	
				"</script>\n";
		}
		
		function verifyAdmin(&$form = null) {
			
			        $delete = null;
					$edit = null;
					$id = null;
							
			if (isset($_GET['delete']))
				$delete = $_GET['delete'];
			
			if (isset($_GET['edit']))
				$edit = $_GET['edit'];
			
			if (isset($_GET['id']))
				$id = (int)$_GET['id'];
						
			if ($delete) {
				if (!$this->delete($id))
					return false;
				
				tooltip::display(
					_("Item has been successfully deleted."),
					TOOLTIP_SUCCESS);
				
				return true;
			}

			if (!$form->verify())
				return false;

			if ($edit) {
					$values = $form->getPostArray();
					if (!$this->edit($id, $form->getPostArray()))
					return false;
				tooltip::display(
					_("Item has been successfully updated."),
					TOOLTIP_SUCCESS);
				
				return true;
			}
			
			if ($this->userPermissionIDs)
				return false;
			
			if (!$this->add($form->getPostArray()))
				return false;
				
			tooltip::display(
				_("Item has been successfully created."),
				TOOLTIP_SUCCESS);
			
			$form->reset();
			return true;
		}
		
		function displayAdminHeader()
		{
			
			echo "			
			<table class='list'>" .
				"<thead>" .
				"<tr>" .		
					"<th>"._("Data ID")."</th>" . 
					"<th>"._("Data Display Name")."</th>" .
					"<th>"._("Data Display Title")."</th>" .
					"<th>".__("Dynamic Form")."</th>";
					
					
					
			if ($this->userPermissionType == USER_PERMISSION_TYPE_WRITE)
			echo
					"<th>".__("Edit")."</th>" .
					"<th>".__("Delete")."</th>";

			echo "</tr>" .
				 "</thead>" .
				 "<tbody>";	
		}
		
		function displayAdminData($rows)
		{
			
			while($row = sql::fetch($rows)) {
			echo 
				"<tr>" .
					"<td>" .
					 $row['ID'].
					"</td>" .
					"<td>" .
						"<strong>".$row['Name']."</strong>" .
					"</td>" .	
					"<td>" .
						$row['Title'] .
					"</td>" .
					"<td class='auto-width'>" .
						"<a href='".$this->globalAdminPath."admin/content/dynamicforms&amp;id=".$row['FormID']."' " .
						" class='bold'>" .
						$this->getFormName($row['FormID']) .
						"</a>" .
					"</td>" 
					;
					
			if ($this->userPermissionType == USER_PERMISSION_TYPE_WRITE)
				echo

					"<td>" .
						"<a class='admin-link edit' " .
							"title='Enter edit mode for ".$row['Title']."' " .
							"href='".url::uri('id, edit, delete') .
							"&amp;id=".$row['ID']."&amp;edit=1'>" .
						"</a>" .
					"</td>" .
					"<td>" .
						"<a class='admin-link delete confirm-link' " .
							"title='Delete Dynamic Data Display: ".$row['Title']."' " .
						"href='".url::uri('id, edit, delete') .
							"&amp;id=".$row['ID']."&amp;delete=1'>" .
						"</a>" .
					"</td>";					
				}
					echo
				"</tr>";	
		}
		
		function displayAdminForm(&$form) {
				$form->display();
		}
		
		// Interaction with DATA!!
		function getDisplays()
		{
				$rows = sql::run(
				" SELECT * FROM `{dynamicdata}`" .
				" ORDER BY `ID` ASC");	
				
						return $rows;
		}
		function getDisyplayFields($ID) 
		{
				$fields = sql::fetch(
				sql::run(
				" SELECT `Fields` FROM `{dynamicdata}`" .
				" WHERE `ID` = ".(int)$ID."
				"));	
				
						return $fields['Fields'];
		}
		function getDynamicForms()	
		{
				$rows = sql::run(
				" SELECT * FROM `{dynamicforms}`" .
				" ORDER BY `Title`"
				);	
				
						return $rows;
		}
		function getFormName($ID)
		{
				$formname = sql::fetch(
				sql::run("
				SELECT `Title` FROM `{dynamicforms}`".
				"WHERE `ID` = ".(int)$ID."
				"));
				
						return $formname['Title'];
		}
		function getFormFields($ID)
		{
				$rows = sql::run(
				" SELECT `ID`, `Title`, `Name` FROM `{dynamicformfields}`" .
				" WHERE `FormID` = ".(int)$ID." ".
				" AND `Title` != ''".	
                                " AND `Name` != '' ".
				" ORDER BY `ID` ASC"
				);	
				
						return $rows;	
		}
		function getFormOrder($ID)
		{
				$order = sql::fetch(
				sql::run("
				SELECT `Order` FROM `{dynamicdata}`".
				"WHERE `ID` = ".(int)$ID."
				"));
				
						return $order['Order'];
		}
		
		function ajaxRequest() {
			if (!$GLOBALS['USER']->loginok || 
				!$GLOBALS['USER']->data['Admin']) 
			{
				tooltip::display(
					__("Request can only be accessed by administrators!"),
					TOOLTIP_ERROR);
				return true;
			}
			
			$ajax = null;
			
			if (isset($_GET['ajax']))
				$ajax 	= $_GET['ajax'];
				$formid	= $_POST['formid'];
				$dataid	= $_POST['dataid'];
			
			if ($ajax) {
				$permission = userPermissions::check(
					$GLOBALS['USER']->data['ID'],
					$this->adminPath);
				
				if (~$permission['PermissionType'] & USER_PERMISSION_TYPE_WRITE) {
					tooltip::display(
						__("You do not have permission to access this path!"),
						TOOLTIP_ERROR);
					return true;
				}
				$fields  = $this->getFormFields($formid);
				
					/// We need our fields data set!
				echo "
				<label class='form-entry-title' for='entryFields'> Display fields: </label>\n
				<div class='form-entry-content'>
				";
				$i = 0;
				while($field = sql::fetch($fields))
				{
					$i = $i +1;
                                        
					echo " <label>\n  <a href='#style' class='field-link' field='".$field['Name']."'>".substr($field['Title'],0, 23)."</a> \n </label>";	
				}
	
				echo "</div>";
				
					/// We also need to change our Order By field!
				   	// Let's prepare our data!	
					$selects = $this->getFormFields($formid);
					$order	 = $this->getFormOrder($dataid);
				echo "<div class='form-entry form-entry-order'>
				<label class='form-entry-title' for='entryOrder'>Order by:</label>\n
				<div class='form-entry-content'>
				";	
				
				echo "<select id='entryOrder' class='select-entry' style='width:160px;' name='Order'>";
						
				while($select = sql::fetch($selects))
				{	
					echo  "<option value='".$select['ID']."'";
					if($select['ID'] == $order)
					{
					echo "selected='selected' ";	
					}
					echo ">";
					echo "".substr($select['Title'],0, 23)."";
					echo "</option>\n";
				}
						
				echo "</select>";
				echo "</div>";	
				}	
				
			
				return true;
	
		}				
		// End of data interaction!!
		
		function displayAdmin() {		
		$this->jQueryFunctions();
		admin::displayTitle(_('Dynamic Data Dsiplay'));
		
		$this->displayAdminDescription();	
		
		// Check for outside variables first.
		$delete = null;
		$edit = null;
		$id = 0;                
      				
		if (isset($_GET['delete']))
			$delete = $_GET['delete'];
		
		if (isset($_GET['edit']))
			$edit = $_GET['edit'];
		
		if (isset($_GET['id']))
			$id = (int)$_GET['id'];
			
			
		    echo "<div class='admin-content'>";	
			/// Our Form for adding and editing diplay!
			$form = new form(
					($edit?
						_("Edit Dynamic Display"):
						_("New Dynamic Display")),
					'displaydataform');
			
			
			if (!$edit)
			$form->action = url::uri('id, delete, limit');
			
			$form->add(
					"<div class='disyplacode'></div>",
					null,
					FORM_STATIC_TEXT);	
			
			$form->add(
					"<div id='displayID' dataID='".$id."' style='display:none'></div>",
					null,
					FORM_STATIC_TEXT);		
					
			$form->add(
					__('Unique name'),
					'Name',
					FORM_INPUT_TYPE_TEXT,
					true);
				$form->setStyle('width: 350px;');	
				
			$form->add(
					__('Title'),
					'Title',
					FORM_INPUT_TYPE_TEXT,
					true);
				$form->setStyle('width: 350px;');				
			
			$form->add(
					__('Dynamic Form'),
					'FormID',
					FORM_INPUT_TYPE_SELECT,
					true); 
				$form->setStyle('width: 365px;');
				
				$values = $this->getDynamicForms();
				while($value = sql::fetch($values)) 
				{
				$form->addValue($value['ID'], $value['Title']);
				}
				
				$form->add(
					__('Display options'),
					'd-options',
					FORM_OPEN_FRAME_CONTAINER,
					true);
									
				$form->add(
						"<div class='resultdata'></div>",
						null,
						FORM_STATIC_TEXT);	
				
				$form->add(
							'Display fields',
							'Fields',
							FORM_INPUT_TYPE_CHECKBOX,
							false);
					$form->setValueType(FORM_VALUE_TYPE_ARRAY);
					
				$form->add(
					__('Limit'),
					'Limit',
					FORM_INPUT_TYPE_TEXT,
					false);
				$form->setValueType(FORM_VALUE_TYPE_INT);
				
				$form->setStyle('width: 145px;');	
				
				$form->add(
						__('Order by'),
						'Order',
						FORM_INPUT_TYPE_SELECT,
						false);
					$form->setStyle('width: 160px;');								
															
				$form->add(
					null,
					null,
					FORM_CLOSE_FRAME_CONTAINER);
	
			$form->add(
					"<div id='style'></div>",
					null,
					FORM_STATIC_TEXT);	
			
			
			$form->add(
					__('Display styling'),
					'style-options',
					FORM_OPEN_FRAME_CONTAINER,
					true);
										
			$form->add(
						"<a href='#' class='formHelp hopen'>Show help</a>",
						null,
						FORM_STATIC_TEXT);											
			$form->add(
						"<a href='#' class='formHelp hclose'>Hide help</a>",
						null,
						FORM_STATIC_TEXT);			
												
			$form->add(
						"<div class='dataHelp'>
						<img src='".$this->moduleURL."lib/modules/dynamicdata/img/help.png' />
						</div>",
						null,
						FORM_STATIC_TEXT);	
			
			$form->add(
					__('HTML Style'),
					'htmlstyle',
					FORM_INPUT_TYPE_EDITOR,
					false);
			$form->setValueType(FORM_VALUE_TYPE_HTML);
						
			$form->add(
					null,
					null,
					FORM_CLOSE_FRAME_CONTAINER);	
	
		    $form->addSubmitButtons();
				
			if ($edit) {
				$form->add(
					__('Cancel'),
					'cancelbutton',
					 FORM_INPUT_TYPE_BUTTON);
				$form->addAttributes("onclick=\"window.location='".
					str_replace('&amp;', '&', url::uri('id, edit, delete'))."'\"");
			}
			
			$selected = null;
			$verifyok = false;
			
			if ($id)
				$selected = sql::fetch(sql::run(
					" SELECT `ID` FROM `{dynamicdata}`" .
					" WHERE `ID` = '".$id."'"));
			
			if ($this->userPermissionType & USER_PERMISSION_TYPE_WRITE &&
				((!$edit && !$delete) || $selected))
				$verifyok = $this->verifyAdmin($form);		
				
			
				///// Displays DATA
				$rows = $this->getDisplays();		
									
				$this->displayAdminHeader();
				 
				if (sql::rows($rows))
				{
				$this->displayAdminData($rows);
				}else{
				tooltip::display(
					__("No dynamic data displays found."),
					TOOLTIP_NOTIFICATION);
				}
				 
				echo "</tbody>" .
					 "</table>" .
					 "<br />";	
				
				
				// Let's display our form!
				echo
					"<a name='adminform'></a>
					";
					
				if ($this->userPermissionType & USER_PERMISSION_TYPE_WRITE &&
					(!$this->userPermissionIDs || ($edit && $selected)))
				{

					if ($edit && $selected && ($verifyok || !$form->submitted())) {
						$selected = sql::fetch(sql::run(
							" SELECT * FROM `{dynamicdata}`" .
							" WHERE `ID` = '".$id."'"));
						
						$form->setValues($selected);
					}
					
					$this->displayAdminForm($form);		
				
				}
				
				
				echo "</div>";	//admin-content
					
			}
						
			function add($values) {
                          
                         
				if (!is_array($values))
					return false;
				if (!empty($values['Fields'])) {	
				$fields = implode("|", $values['Fields']);
				}
                                if($values['Limit'] == 0)
                                {
                                    $limit = 1;
                                } else {
                                    $limit = sql::escape($values['Limit']);
                                    
                                }			
                                
                                $unique = sql::fetch(sql::run(
					" SELECT `Name` FROM `{dynamicdata}`".
					" WHERE `Name` ='".
					sql::escape($values['Name'])."'" 
					));
				
				if(!empty($unique['Name'])) {	
					tooltip::display(
						__("Item couldn't be created! Display with that name already exists!"),
						TOOLTIP_ERROR);
					return false;
				}
								
				$newid = sql::run(
					" INSERT INTO `{dynamicdata}` SET ".
					" `FormID` = '".
						(int)$values['FormID']."'," .
				    " `Name` = '".
						sql::escape($values['Name'])."'," .
				    " `Title` = '".
						sql::escape($values['Title'])."'," .
				    " `Fields` = '".
						$fields."'," .
				    " `Order` = '".
						sql::escape($values['Order'])."'," .
					" `Limit` = '".
						(int)$limit."',".
                                        " `htmlstyle` = '".
						sql::escape($values['htmlstyle'])."'
						");
                                                                 
				if (!$newid) {
					tooltip::display(
						sprintf(_("Item couldn't be created! Error: %s"), 
							sql::error()),
						TOOLTIP_ERROR);
					return false;
				}
				
				return $newid;
			}
			function delete($id) {
				if (!(int)$id)
					return false;
					
				sql::run(
					" DELETE FROM `{dynamicdata}` " .
					" WHERE `ID` = '".(int)$id."'");
				
				return true;
			}
	
			function edit($id, $values) {
				if (!(int)$id)
					return false;
					if (!is_array($values))
					return false;
				
				if (!empty($values['Fields'])) {	
				$fields = implode("|", $values['Fields']);
				}
                                if($values['Limit'] == 0)
                                {
                                    $limit = 1;
                                } else {
                                    $limit = sql::escape($values['Limit']);
                                }
				sql::run(
					" UPDATE `{dynamicdata}` SET ".
					" `Name` = '".
						sql::escape($values['Name'])."',".			
					" `Title` = '".
						sql::escape($values['Title'])."',".		
					" `FormID` = '".
						sql::escape($values['FormID'])."',".			
					" `Fields` = '".
						$fields."',".	
					" `Order` = '".
						sql::escape($values['Order'])."',".		
					" `Limit` = '".
						(int)$limit."',".
                                        " `htmlstyle` = '".
						sql::escape($values['htmlstyle'])."'".	
					" WHERE `ID` = '".(int)$id."'");
                                
					
				if (sql::affected() == -1) {
					tooltip::display(
						sprintf(_("Item couldn't be updated! Error: %s"), 
							sql::error()),
						TOOLTIP_ERROR);
					return false;
				}
				
				return true;
			}
			
		
        // Client part!
             
        function displayDynamicDisplay($display, $record_id = null)
	{
           global $pdisplay, $parser, $parser_record;
           $pdisplay = $display;
           $parser = new StringParser_BBCode();     
            
                /// Database interaction for clients!
                function dynamicDisplayData($display)
                {
                    $data = sql::fetch(sql::run(
                    " SELECT * FROM `{dynamicdata}`".
                    " WHERE `Name` ='".
                    $display."'" 
                    ));
                    return $data;
                }    
                function dynamicFormData($ID)
                {
                    $data = sql::fetch(sql::run(
                    " SELECT `ID`, `Title`, `SQLTABLE` FROM `{dynamicforms}`".
                    " WHERE `ID` ='".$ID."'" 
                    ));
                    return $data;
                }
                function dynamicFormRecords($table, $order, $limit)
                {
                    $columns = sql::run("SHOW COLUMNS FROM `{".sql::escape($table)."}`");
                    if(!sql::rows($columns))
                      return false;

                    while($column = sql::fetch($columns))
                    {
                      if ($column['Field'] == $order)
                      {
                        $order = $order;                
                      } else {
                         $order = "ID";
                      }
                    }           
                    $data = sql::run(
                    " SELECT * FROM `{".$table."}`" .
                    " ORDER BY `".$order."`" .
                    " LIMIT ".$limit.""
                    );
                    return $data;
                }

                function getFieldName($formid, $fieldid)
                {
                    $data = sql::fetch(sql::run(
                    " SELECT `Name` FROM `{dynamicformfields}`" .
                    " WHERE `FormID` = ".$formid." ".
                    " AND `ID` = ".$fieldid." "
                    ));
                    return $data['Name'];    
                }
                function getFieldData($table, $field, $record)
                {
                    $columns = sql::run("SHOW COLUMNS FROM `{".sql::escape($table)."}`");

                    if(!sql::rows($columns))
                      return false;

                    while($column = sql::fetch($columns))
                    {
                      if ($column['Field'] == $field )
                      {
                         $fields = sql::fetch(sql::run("
                             SELECT `".sql::escape($field)."`FROM `{".sql::escape($table)."}` WHERE ID = ".$record.""));
                         return $fields[''.$field.'']." ";                 
                      }
                    }
                    return false;
                   
          
                }
                function partialProcessor ($action, $attributes, $content, $params, &$node_object) 
                {         
                    return $content;
                 } 
                 function partialNullProcessor ($action, $attributes, $content, $params, &$node_object) 
                {         
                    return " ";
                 }
                function detailedNullProcessor ($action, $attributes, $content, $params, &$node_object) 
                {         
                    return " ";
                 }
                function loopProcessor ($action, $attributes, $content, $params, &$node_object)
                {
                    global $pdisplay;
                    $formid   = dynamicDisplayData($pdisplay);  
                    $formsql  = dynamicFormData($formid['FormID']);
                    $order    = getFieldName($formid['FormID'], $formid['Order']);
                    $formdata = dynamicFormRecords($formsql['SQLTABLE'], $order, $formid['Limit']);
                    while($record = sql::fetch($formdata))
                    {
                      $parser_record = new StringParser_BBCode();  
                      $parser_record->addCode ('fields', 'usecontent?', 'fieldsProcessor', array ('usecontent_param' => 'default', 'record' => $record['ID'], 'sql' => $formsql['SQLTABLE']),
                      'inline', array ('block', 'inline'), array ('link')); 
                          $data.= $parser_record->parse($content);
                          unset($parser_record);
                    }

                   return $data;
                    
                }  
                function detailedProcessor ($action, $attributes, $content, $params, &$node_object)
                {
                    global $pdisplay;
                     $formid   = dynamicDisplayData($pdisplay);  
                     $formsql  = dynamicFormData($formid['FormID']);
                      $parser_record = new StringParser_BBCode();  
                      $parser_record->addCode ('fields', 'usecontent?', 'fieldsProcessor', array ('usecontent_param' => 'default', 'record' => $params['record'], 'sql' => $formsql['SQLTABLE']),
                      'inline', array ('block', 'inline'), array ('link')); 
                          $data.= $parser_record->parse($content);
                          unset($parser_record);

                   return $data;
                    
                }  
                function fieldsProcessor($action, $attributes, $content, $params, &$node_object)
                {
                    global $pdisplay;
                    $record   = $params['record'];
                    $field    = getFieldData($params['sql'], $content, $record);
         
                      if($field)
                    
                    {
                        if($attributes['default'] == "link")
                        {
                            return "<a href='".$_SERVER['REQUEST_URI']."/".$pdisplay."/".$record."'>".$field."</a>";
                        } else{
                            return $field;
                        }
                    }
                     else {
                            return " ";
                    }
                 
                
                }
                function dataProcessor($data, $type = null, $record = null)
                {
                     global $parser;
                     if($type == "loop")
                     {
                         $parser->addCode ('loop', 'usecontent?', 'loopProcessor', array ('usecontent_param' => 'default'),
                         'inline', array ('block', 'inline'), array ('link'));
                            $new_data = $parser->parse($data);
                                return $new_data;
                                unset($parser);
                    } else if($type == "detailed") {
                         $parser->addCode ('detailed', 'usecontent?', 'detailedProcessor', array ('usecontent_param' => 'default', 'record' => $record),
                         'inline', array ('block', 'inline'), array ('link'));
                            $new_data = $parser->parse($data);
                                return $new_data;
                                unset($parser);
                    } else
                    {
                        return false;
                    }
                }
                /// Let's check if user is accesing partial or detailed data!
                    
                    if(isset($record_id))
                    {
                    $parser->addCode ('partial', 'usecontent?', 'partialNullProcessor', array ('usecontent_param' => 'default'),
                              'inline', array ('block', 'inline'), array ('link'));     

                    $rows = sql::fetch(sql::run(
				" SELECT * FROM `{dynamicdata}`" .
				" WHERE `Name` = '".sql::escape($display)."' "
				));	
				
				if($rows)
				{	
                                        echo "<div id='dynamicDisplay-".$rows['ID']."'>";
                                       $data   = $parser->parse ($rows['htmlstyle']);
                                       $data   = dataProcessor($data, "detailed", $record_id);
                                       echo $data;
                                       echo "</div>";
                                unset($parser);     
             			
				}else{
					tooltip::display(
						__("This dynamic display doesn't exist!"),
						TOOLTIP_ERROR);
				}
                      } else
                    {
                 
                    $parser->addCode ('partial', 'usecontent?', 'partialProcessor', array ('usecontent_param' => 'default'),
                              'inline', array ('block', 'inline'), array ('link'));     
                    $parser->addCode ('detailed', 'usecontent?', 'detailedNullProcessor', array ('usecontent_param' => 'default'),
                              'inline', array ('block', 'inline'), array ('link'));

                    $rows = sql::fetch(sql::run(
				" SELECT * FROM `{dynamicdata}`" .
				" WHERE `Name` = '".sql::escape($display)."' "
				));	
				
				if($rows)
				{	
                                       echo "<div id='dynamicDisplay-".$rows['ID']."'>";
                                       $data_loop   = $parser->parse ($rows['htmlstyle']);
                                       $data_loop   = dataProcessor($data_loop, "loop");
                                       echo $data_loop;
                                       echo "</div>";
                                       
                                     
             			 unset($parser);     
                                 
				}else{
					tooltip::display(
						__("This dynamic display doesn't exist!"),
						TOOLTIP_ERROR);
				}
                    }
				
	}	
	function displayArguments()
	{
		if (!$this->arguments)
		{
			return false;
			
		}else {
                                if(url::path()) {
                                        $path = explode("/", url::path());
                                        $display = $path[0];
                                        $record  = $path[1];
                                         $this->displayDynamicDisplay($display, $record);
                                            return true;
                                } else {
                                        $this->displayDynamicDisplay($this->arguments);
                                            return true;
                                   }
		} 
	}		
	function display() 
	{
		if ($this->displayArguments())
		{
			return;

		} else {
					tooltip::display(
						__("Arguments for dynamic display are empty!"),
						TOOLTIP_ERROR);
		}
		
	}
 }
 ?>